module Funcons.Core.Library (
    funcons, entities, types,
   module Funcons.Core.Computations.Sorts,
   module Funcons.Core.Computations.ControlFlow.Normal.Sequencing.LeftToRight,
   module Funcons.Core.Computations.ControlFlow.Normal.Sequencing.Atomic,
   module Funcons.Core.Computations.ControlFlow.Normal.Sequencing.Sequential,
   module Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.VectorMap,
   module Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.SetMap,
   module Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.ListMap,
   module Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.TupleMap,
   module Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.MapMap,
   module Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.ListsMap,
   module Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.FilteringCollections.MultisetFilter,
   module Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.FilteringCollections.SetFilter,
   module Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.FilteringCollections.MapFilter,
   module Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.FilteringCollections.ListFilter,
   module Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.ReducingCollections.ListFoldl,
   module Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.ReducingCollections.ListFoldr,
   module Funcons.Core.Computations.ControlFlow.Normal.Iterating.Indefinite.While,
   module Funcons.Core.Computations.ControlFlow.Normal.Iterating.Indefinite.DoWhile,
   module Funcons.Core.Computations.ControlFlow.Normal.Choosing.IfThenElse,
   module Funcons.Core.Computations.ControlFlow.Abnormal.Stuck,
   module Funcons.Core.Computations.ControlFlow.Abnormal.Throwing.Thrown,
   module Funcons.Core.Computations.ControlFlow.Abnormal.Throwing.HandleThrown,
   module Funcons.Core.Computations.ControlFlow.Abnormal.Throwing.Finally,
   module Funcons.Core.Computations.ControlFlow.Abnormal.Throwing.Throw,
   module Funcons.Core.Computations.ControlFlow.Abnormal.Throwing.HandleRecursively,
   module Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Plug,
   module Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.ResumeSignal,
   module Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Shift,
   module Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Prompt,
   module Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Control,
   module Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.CallCc,
   module Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Reset,
   module Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Hole,
   module Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Abort,
   module Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.ControlSignal,
   module Funcons.Core.Computations.ControlFlow.Abnormal.Failing.Else,
   module Funcons.Core.Computations.ControlFlow.Abnormal.Failing.CheckTrue,
   module Funcons.Core.Computations.ControlFlow.Abnormal.Failing.Fail,
   module Funcons.Core.Computations.ControlFlow.Abnormal.Failing.Signals,
   module Funcons.Core.Computations.ControlFlow.Abnormal.Failing.Dereference,
   module Funcons.Core.Computations.ControlFlow.Abnormal.Failing.Failed,
   module Funcons.Core.Computations.DataFlow.Interacting.PrintList,
   module Funcons.Core.Computations.DataFlow.Interacting.Print,
   module Funcons.Core.Computations.DataFlow.Interacting.StandardOut,
   module Funcons.Core.Computations.DataFlow.Interacting.Read,
   module Funcons.Core.Computations.DataFlow.Interacting.StandardIn,
   module Funcons.Core.Computations.DataFlow.Effect,
   module Funcons.Core.Computations.DataFlow.Storing.GeneralVariables.AllocateMap,
   module Funcons.Core.Computations.DataFlow.Storing.GeneralVariables.GeneralAssign,
   module Funcons.Core.Computations.DataFlow.Storing.GeneralVariables.GeneralAssigned,
   module Funcons.Core.Computations.DataFlow.Storing.GeneralVariables.AllocateVector,
   module Funcons.Core.Computations.DataFlow.Storing.Stores,
   module Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.CurrentValue,
   module Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.Assigned,
   module Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.AllocateInitialisedVariable,
   module Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.AllocateVariable,
   module Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.DeallocateVariable,
   module Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.Assign,
   module Funcons.Core.Computations.DataFlow.Storing.Store,
   module Funcons.Core.Computations.DataFlow.Storing.Variables,
   module Funcons.Core.Computations.DataFlow.Linking.AllocateInitialisedLink,
   module Funcons.Core.Computations.DataFlow.Linking.AllocateLink,
   module Funcons.Core.Computations.DataFlow.Linking.FollowIfLink,
   module Funcons.Core.Computations.DataFlow.Linking.LinkStore,
   module Funcons.Core.Computations.DataFlow.Linking.Links,
   module Funcons.Core.Computations.DataFlow.Linking.FollowLink,
   module Funcons.Core.Computations.DataFlow.Linking.LinkStores,
   module Funcons.Core.Computations.DataFlow.Linking.SetLink,
   module Funcons.Core.Computations.DataFlow.Giving.Given,
   module Funcons.Core.Computations.DataFlow.Giving.Give,
   module Funcons.Core.Computations.DataFlow.Giving.GivenValue,
   module Funcons.Core.Computations.DataFlow.Generating.AtomGenerator,
   module Funcons.Core.Computations.DataFlow.Generating.FreshAtom,
   module Funcons.Core.Computations.DataFlow.Generating.FreshBinder,
   module Funcons.Core.Computations.DataFlow.Binding.Recursion.Recursive,
   module Funcons.Core.Computations.DataFlow.Binding.Recursion.BindRecursively,
   module Funcons.Core.Computations.DataFlow.Binding.Recursion.BoundRecursively,
   module Funcons.Core.Computations.DataFlow.Binding.Bound,
   module Funcons.Core.Computations.DataFlow.Binding.Environments,
   module Funcons.Core.Computations.DataFlow.Binding.Scope,
   module Funcons.Core.Computations.DataFlow.Binding.Accumulate,
   module Funcons.Core.Computations.DataFlow.Binding.Bind,
   module Funcons.Core.Computations.DataFlow.Binding.Environment,
   module Funcons.Core.Values.Types,
   module Funcons.Core.Values.CompositeValues.Collections.DirectedGraphs,
   module Funcons.Core.Values.CompositeValues.Collections.Tuples,
   module Funcons.Core.Values.CompositeValues.AlgebraicDatatypeValues.Variants,
   module Funcons.Core.Values.CompositeValues.AlgebraicDatatypeValues.Records,
   module Funcons.Core.Values.CompositeValues.AlgebraicDatatypeValues.References,
   module Funcons.Core.Values.PrimitiveValues.UnitType,
   module Funcons.Core.Values.PrimitiveValues.UnicodeCharacters,
   module Funcons.Core.Values.PrimitiveValues.Bits,
   module Funcons.Core.Values.PrimitiveValues.Strings,
   module Funcons.Core.Values.PrimitiveValues.Numbers.Integers,
   module Funcons.Core.Values.PrimitiveValues.Numbers.Rationals,
   module Funcons.Core.Values.PrimitiveValues.Numbers.IeeeFloats,
   module Funcons.Core.Values.PrimitiveValues.Booleans,
   module Funcons.Core.Abstractions.Closures.Close,
   module Funcons.Core.Abstractions.Closures.Closure,
   module Funcons.Core.Abstractions.Patterns.PatternPrefer,
   module Funcons.Core.Abstractions.Patterns.Match,
   module Funcons.Core.Abstractions.Patterns.Patterns,
   module Funcons.Core.Abstractions.Patterns.PatternUnite,
   module Funcons.Core.Abstractions.Patterns.PatternAny,
   module Funcons.Core.Abstractions.Patterns.Case,
   module Funcons.Core.Abstractions.Patterns.MatchLoosely,
   module Funcons.Core.Abstractions.Patterns.PatternBind,
   module Funcons.Core.Abstractions.IsGroundValue,
   module Funcons.Core.Abstractions.Functions.Apply,
   module Funcons.Core.Abstractions.Functions.Supply,
   module Funcons.Core.Abstractions.Functions.BindingLambda,
   module Funcons.Core.Abstractions.Functions.Curry,
   module Funcons.Core.Abstractions.Functions.Lambda,
   module Funcons.Core.Abstractions.Functions.Uncurry,
   module Funcons.Core.Abstractions.Functions.PartialApply,
   module Funcons.Core.Abstractions.Functions.Compose,
    ) where 
import Funcons.EDSL
import Funcons.Core.Computations.Sorts hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.Sorts
import Funcons.Core.Computations.ControlFlow.Normal.Sequencing.LeftToRight hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Normal.Sequencing.LeftToRight
import Funcons.Core.Computations.ControlFlow.Normal.Sequencing.Atomic hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Normal.Sequencing.Atomic
import Funcons.Core.Computations.ControlFlow.Normal.Sequencing.Sequential hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Normal.Sequencing.Sequential
import Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.VectorMap hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.VectorMap
import Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.SetMap hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.SetMap
import Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.ListMap hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.ListMap
import Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.TupleMap hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.TupleMap
import Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.MapMap hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.MapMap
import Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.ListsMap hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.ListsMap
import Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.FilteringCollections.MultisetFilter hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.FilteringCollections.MultisetFilter
import Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.FilteringCollections.SetFilter hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.FilteringCollections.SetFilter
import Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.FilteringCollections.MapFilter hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.FilteringCollections.MapFilter
import Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.FilteringCollections.ListFilter hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.FilteringCollections.ListFilter
import Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.ReducingCollections.ListFoldl hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.ReducingCollections.ListFoldl
import Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.ReducingCollections.ListFoldr hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.ReducingCollections.ListFoldr
import Funcons.Core.Computations.ControlFlow.Normal.Iterating.Indefinite.While hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Normal.Iterating.Indefinite.While
import Funcons.Core.Computations.ControlFlow.Normal.Iterating.Indefinite.DoWhile hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Normal.Iterating.Indefinite.DoWhile
import Funcons.Core.Computations.ControlFlow.Normal.Choosing.IfThenElse hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Normal.Choosing.IfThenElse
import Funcons.Core.Computations.ControlFlow.Abnormal.Stuck hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Abnormal.Stuck
import Funcons.Core.Computations.ControlFlow.Abnormal.Throwing.Thrown hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Abnormal.Throwing.Thrown
import Funcons.Core.Computations.ControlFlow.Abnormal.Throwing.HandleThrown hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Abnormal.Throwing.HandleThrown
import Funcons.Core.Computations.ControlFlow.Abnormal.Throwing.Finally hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Abnormal.Throwing.Finally
import Funcons.Core.Computations.ControlFlow.Abnormal.Throwing.Throw hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Abnormal.Throwing.Throw
import Funcons.Core.Computations.ControlFlow.Abnormal.Throwing.HandleRecursively hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Abnormal.Throwing.HandleRecursively
import Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Plug hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Plug
import Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.ResumeSignal hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.ResumeSignal
import Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Shift hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Shift
import Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Prompt hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Prompt
import Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Control hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Control
import Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.CallCc hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.CallCc
import Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Reset hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Reset
import Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Hole hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Hole
import Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Abort hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Abort
import Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.ControlSignal hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.ControlSignal
import Funcons.Core.Computations.ControlFlow.Abnormal.Failing.Else hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Abnormal.Failing.Else
import Funcons.Core.Computations.ControlFlow.Abnormal.Failing.CheckTrue hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Abnormal.Failing.CheckTrue
import Funcons.Core.Computations.ControlFlow.Abnormal.Failing.Fail hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Abnormal.Failing.Fail
import Funcons.Core.Computations.ControlFlow.Abnormal.Failing.Signals hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Abnormal.Failing.Signals
import Funcons.Core.Computations.ControlFlow.Abnormal.Failing.Dereference hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Abnormal.Failing.Dereference
import Funcons.Core.Computations.ControlFlow.Abnormal.Failing.Failed hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.ControlFlow.Abnormal.Failing.Failed
import Funcons.Core.Computations.DataFlow.Interacting.PrintList hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Interacting.PrintList
import Funcons.Core.Computations.DataFlow.Interacting.Print hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Interacting.Print
import Funcons.Core.Computations.DataFlow.Interacting.StandardOut hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Interacting.StandardOut
import Funcons.Core.Computations.DataFlow.Interacting.Read hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Interacting.Read
import Funcons.Core.Computations.DataFlow.Interacting.StandardIn hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Interacting.StandardIn
import Funcons.Core.Computations.DataFlow.Effect hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Effect
import Funcons.Core.Computations.DataFlow.Storing.GeneralVariables.AllocateMap hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Storing.GeneralVariables.AllocateMap
import Funcons.Core.Computations.DataFlow.Storing.GeneralVariables.GeneralAssign hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Storing.GeneralVariables.GeneralAssign
import Funcons.Core.Computations.DataFlow.Storing.GeneralVariables.GeneralAssigned hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Storing.GeneralVariables.GeneralAssigned
import Funcons.Core.Computations.DataFlow.Storing.GeneralVariables.AllocateVector hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Storing.GeneralVariables.AllocateVector
import Funcons.Core.Computations.DataFlow.Storing.Stores hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Storing.Stores
import Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.CurrentValue hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.CurrentValue
import Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.Assigned hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.Assigned
import Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.AllocateInitialisedVariable hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.AllocateInitialisedVariable
import Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.AllocateVariable hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.AllocateVariable
import Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.DeallocateVariable hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.DeallocateVariable
import Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.Assign hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.Assign
import Funcons.Core.Computations.DataFlow.Storing.Store hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Storing.Store
import Funcons.Core.Computations.DataFlow.Storing.Variables hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Storing.Variables
import Funcons.Core.Computations.DataFlow.Linking.AllocateInitialisedLink hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Linking.AllocateInitialisedLink
import Funcons.Core.Computations.DataFlow.Linking.AllocateLink hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Linking.AllocateLink
import Funcons.Core.Computations.DataFlow.Linking.FollowIfLink hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Linking.FollowIfLink
import Funcons.Core.Computations.DataFlow.Linking.LinkStore hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Linking.LinkStore
import Funcons.Core.Computations.DataFlow.Linking.Links hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Linking.Links
import Funcons.Core.Computations.DataFlow.Linking.FollowLink hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Linking.FollowLink
import Funcons.Core.Computations.DataFlow.Linking.LinkStores hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Linking.LinkStores
import Funcons.Core.Computations.DataFlow.Linking.SetLink hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Linking.SetLink
import Funcons.Core.Computations.DataFlow.Giving.Given hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Giving.Given
import Funcons.Core.Computations.DataFlow.Giving.Give hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Giving.Give
import Funcons.Core.Computations.DataFlow.Giving.GivenValue hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Giving.GivenValue
import Funcons.Core.Computations.DataFlow.Generating.AtomGenerator hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Generating.AtomGenerator
import Funcons.Core.Computations.DataFlow.Generating.FreshAtom hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Generating.FreshAtom
import Funcons.Core.Computations.DataFlow.Generating.FreshBinder hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Generating.FreshBinder
import Funcons.Core.Computations.DataFlow.Binding.Recursion.Recursive hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Binding.Recursion.Recursive
import Funcons.Core.Computations.DataFlow.Binding.Recursion.BindRecursively hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Binding.Recursion.BindRecursively
import Funcons.Core.Computations.DataFlow.Binding.Recursion.BoundRecursively hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Binding.Recursion.BoundRecursively
import Funcons.Core.Computations.DataFlow.Binding.Bound hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Binding.Bound
import Funcons.Core.Computations.DataFlow.Binding.Environments hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Binding.Environments
import Funcons.Core.Computations.DataFlow.Binding.Scope hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Binding.Scope
import Funcons.Core.Computations.DataFlow.Binding.Accumulate hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Binding.Accumulate
import Funcons.Core.Computations.DataFlow.Binding.Bind hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Binding.Bind
import Funcons.Core.Computations.DataFlow.Binding.Environment hiding (funcons,types,entities)
import qualified Funcons.Core.Computations.DataFlow.Binding.Environment
import Funcons.Core.Values.Types hiding (funcons,types,entities)
import qualified Funcons.Core.Values.Types
import Funcons.Core.Values.CompositeValues.Collections.DirectedGraphs hiding (funcons,types,entities)
import qualified Funcons.Core.Values.CompositeValues.Collections.DirectedGraphs
import Funcons.Core.Values.CompositeValues.Collections.Tuples hiding (funcons,types,entities)
import qualified Funcons.Core.Values.CompositeValues.Collections.Tuples
import Funcons.Core.Values.CompositeValues.AlgebraicDatatypeValues.Variants hiding (funcons,types,entities)
import qualified Funcons.Core.Values.CompositeValues.AlgebraicDatatypeValues.Variants
import Funcons.Core.Values.CompositeValues.AlgebraicDatatypeValues.Records hiding (funcons,types,entities)
import qualified Funcons.Core.Values.CompositeValues.AlgebraicDatatypeValues.Records
import Funcons.Core.Values.CompositeValues.AlgebraicDatatypeValues.References hiding (funcons,types,entities)
import qualified Funcons.Core.Values.CompositeValues.AlgebraicDatatypeValues.References
import Funcons.Core.Values.PrimitiveValues.UnitType hiding (funcons,types,entities)
import qualified Funcons.Core.Values.PrimitiveValues.UnitType
import Funcons.Core.Values.PrimitiveValues.UnicodeCharacters hiding (funcons,types,entities)
import qualified Funcons.Core.Values.PrimitiveValues.UnicodeCharacters
import Funcons.Core.Values.PrimitiveValues.Bits hiding (funcons,types,entities)
import qualified Funcons.Core.Values.PrimitiveValues.Bits
import Funcons.Core.Values.PrimitiveValues.Strings hiding (funcons,types,entities)
import qualified Funcons.Core.Values.PrimitiveValues.Strings
import Funcons.Core.Values.PrimitiveValues.Numbers.Integers hiding (funcons,types,entities)
import qualified Funcons.Core.Values.PrimitiveValues.Numbers.Integers
import Funcons.Core.Values.PrimitiveValues.Numbers.Rationals hiding (funcons,types,entities)
import qualified Funcons.Core.Values.PrimitiveValues.Numbers.Rationals
import Funcons.Core.Values.PrimitiveValues.Numbers.IeeeFloats hiding (funcons,types,entities)
import qualified Funcons.Core.Values.PrimitiveValues.Numbers.IeeeFloats
import Funcons.Core.Values.PrimitiveValues.Booleans hiding (funcons,types,entities)
import qualified Funcons.Core.Values.PrimitiveValues.Booleans
import Funcons.Core.Abstractions.Closures.Close hiding (funcons,types,entities)
import qualified Funcons.Core.Abstractions.Closures.Close
import Funcons.Core.Abstractions.Closures.Closure hiding (funcons,types,entities)
import qualified Funcons.Core.Abstractions.Closures.Closure
import Funcons.Core.Abstractions.Patterns.PatternPrefer hiding (funcons,types,entities)
import qualified Funcons.Core.Abstractions.Patterns.PatternPrefer
import Funcons.Core.Abstractions.Patterns.Match hiding (funcons,types,entities)
import qualified Funcons.Core.Abstractions.Patterns.Match
import Funcons.Core.Abstractions.Patterns.Patterns hiding (funcons,types,entities)
import qualified Funcons.Core.Abstractions.Patterns.Patterns
import Funcons.Core.Abstractions.Patterns.PatternUnite hiding (funcons,types,entities)
import qualified Funcons.Core.Abstractions.Patterns.PatternUnite
import Funcons.Core.Abstractions.Patterns.PatternAny hiding (funcons,types,entities)
import qualified Funcons.Core.Abstractions.Patterns.PatternAny
import Funcons.Core.Abstractions.Patterns.Case hiding (funcons,types,entities)
import qualified Funcons.Core.Abstractions.Patterns.Case
import Funcons.Core.Abstractions.Patterns.MatchLoosely hiding (funcons,types,entities)
import qualified Funcons.Core.Abstractions.Patterns.MatchLoosely
import Funcons.Core.Abstractions.Patterns.PatternBind hiding (funcons,types,entities)
import qualified Funcons.Core.Abstractions.Patterns.PatternBind
import Funcons.Core.Abstractions.IsGroundValue hiding (funcons,types,entities)
import qualified Funcons.Core.Abstractions.IsGroundValue
import Funcons.Core.Abstractions.Functions.Apply hiding (funcons,types,entities)
import qualified Funcons.Core.Abstractions.Functions.Apply
import Funcons.Core.Abstractions.Functions.Supply hiding (funcons,types,entities)
import qualified Funcons.Core.Abstractions.Functions.Supply
import Funcons.Core.Abstractions.Functions.BindingLambda hiding (funcons,types,entities)
import qualified Funcons.Core.Abstractions.Functions.BindingLambda
import Funcons.Core.Abstractions.Functions.Curry hiding (funcons,types,entities)
import qualified Funcons.Core.Abstractions.Functions.Curry
import Funcons.Core.Abstractions.Functions.Lambda hiding (funcons,types,entities)
import qualified Funcons.Core.Abstractions.Functions.Lambda
import Funcons.Core.Abstractions.Functions.Uncurry hiding (funcons,types,entities)
import qualified Funcons.Core.Abstractions.Functions.Uncurry
import Funcons.Core.Abstractions.Functions.PartialApply hiding (funcons,types,entities)
import qualified Funcons.Core.Abstractions.Functions.PartialApply
import Funcons.Core.Abstractions.Functions.Compose hiding (funcons,types,entities)
import qualified Funcons.Core.Abstractions.Functions.Compose
funcons = libUnions
    [
     Funcons.Core.Computations.Sorts.funcons
    , Funcons.Core.Computations.ControlFlow.Normal.Sequencing.LeftToRight.funcons
    , Funcons.Core.Computations.ControlFlow.Normal.Sequencing.Atomic.funcons
    , Funcons.Core.Computations.ControlFlow.Normal.Sequencing.Sequential.funcons
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.VectorMap.funcons
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.SetMap.funcons
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.ListMap.funcons
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.TupleMap.funcons
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.MapMap.funcons
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.ListsMap.funcons
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.FilteringCollections.MultisetFilter.funcons
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.FilteringCollections.SetFilter.funcons
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.FilteringCollections.MapFilter.funcons
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.FilteringCollections.ListFilter.funcons
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.ReducingCollections.ListFoldl.funcons
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.ReducingCollections.ListFoldr.funcons
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Indefinite.While.funcons
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Indefinite.DoWhile.funcons
    , Funcons.Core.Computations.ControlFlow.Normal.Choosing.IfThenElse.funcons
    , Funcons.Core.Computations.ControlFlow.Abnormal.Stuck.funcons
    , Funcons.Core.Computations.ControlFlow.Abnormal.Throwing.Thrown.funcons
    , Funcons.Core.Computations.ControlFlow.Abnormal.Throwing.HandleThrown.funcons
    , Funcons.Core.Computations.ControlFlow.Abnormal.Throwing.Finally.funcons
    , Funcons.Core.Computations.ControlFlow.Abnormal.Throwing.Throw.funcons
    , Funcons.Core.Computations.ControlFlow.Abnormal.Throwing.HandleRecursively.funcons
    , Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Plug.funcons
    , Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.ResumeSignal.funcons
    , Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Shift.funcons
    , Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Prompt.funcons
    , Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Control.funcons
    , Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.CallCc.funcons
    , Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Reset.funcons
    , Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Hole.funcons
    , Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Abort.funcons
    , Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.ControlSignal.funcons
    , Funcons.Core.Computations.ControlFlow.Abnormal.Failing.Else.funcons
    , Funcons.Core.Computations.ControlFlow.Abnormal.Failing.CheckTrue.funcons
    , Funcons.Core.Computations.ControlFlow.Abnormal.Failing.Fail.funcons
    , Funcons.Core.Computations.ControlFlow.Abnormal.Failing.Signals.funcons
    , Funcons.Core.Computations.ControlFlow.Abnormal.Failing.Dereference.funcons
    , Funcons.Core.Computations.ControlFlow.Abnormal.Failing.Failed.funcons
    , Funcons.Core.Computations.DataFlow.Interacting.PrintList.funcons
    , Funcons.Core.Computations.DataFlow.Interacting.Print.funcons
    , Funcons.Core.Computations.DataFlow.Interacting.StandardOut.funcons
    , Funcons.Core.Computations.DataFlow.Interacting.Read.funcons
    , Funcons.Core.Computations.DataFlow.Interacting.StandardIn.funcons
    , Funcons.Core.Computations.DataFlow.Effect.funcons
    , Funcons.Core.Computations.DataFlow.Storing.GeneralVariables.AllocateMap.funcons
    , Funcons.Core.Computations.DataFlow.Storing.GeneralVariables.GeneralAssign.funcons
    , Funcons.Core.Computations.DataFlow.Storing.GeneralVariables.GeneralAssigned.funcons
    , Funcons.Core.Computations.DataFlow.Storing.GeneralVariables.AllocateVector.funcons
    , Funcons.Core.Computations.DataFlow.Storing.Stores.funcons
    , Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.CurrentValue.funcons
    , Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.Assigned.funcons
    , Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.AllocateInitialisedVariable.funcons
    , Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.AllocateVariable.funcons
    , Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.DeallocateVariable.funcons
    , Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.Assign.funcons
    , Funcons.Core.Computations.DataFlow.Storing.Store.funcons
    , Funcons.Core.Computations.DataFlow.Storing.Variables.funcons
    , Funcons.Core.Computations.DataFlow.Linking.AllocateInitialisedLink.funcons
    , Funcons.Core.Computations.DataFlow.Linking.AllocateLink.funcons
    , Funcons.Core.Computations.DataFlow.Linking.FollowIfLink.funcons
    , Funcons.Core.Computations.DataFlow.Linking.LinkStore.funcons
    , Funcons.Core.Computations.DataFlow.Linking.Links.funcons
    , Funcons.Core.Computations.DataFlow.Linking.FollowLink.funcons
    , Funcons.Core.Computations.DataFlow.Linking.LinkStores.funcons
    , Funcons.Core.Computations.DataFlow.Linking.SetLink.funcons
    , Funcons.Core.Computations.DataFlow.Giving.Given.funcons
    , Funcons.Core.Computations.DataFlow.Giving.Give.funcons
    , Funcons.Core.Computations.DataFlow.Giving.GivenValue.funcons
    , Funcons.Core.Computations.DataFlow.Generating.AtomGenerator.funcons
    , Funcons.Core.Computations.DataFlow.Generating.FreshAtom.funcons
    , Funcons.Core.Computations.DataFlow.Generating.FreshBinder.funcons
    , Funcons.Core.Computations.DataFlow.Binding.Recursion.Recursive.funcons
    , Funcons.Core.Computations.DataFlow.Binding.Recursion.BindRecursively.funcons
    , Funcons.Core.Computations.DataFlow.Binding.Recursion.BoundRecursively.funcons
    , Funcons.Core.Computations.DataFlow.Binding.Bound.funcons
    , Funcons.Core.Computations.DataFlow.Binding.Environments.funcons
    , Funcons.Core.Computations.DataFlow.Binding.Scope.funcons
    , Funcons.Core.Computations.DataFlow.Binding.Accumulate.funcons
    , Funcons.Core.Computations.DataFlow.Binding.Bind.funcons
    , Funcons.Core.Computations.DataFlow.Binding.Environment.funcons
    , Funcons.Core.Values.Types.funcons
    , Funcons.Core.Values.CompositeValues.Collections.DirectedGraphs.funcons
    , Funcons.Core.Values.CompositeValues.Collections.Tuples.funcons
    , Funcons.Core.Values.CompositeValues.AlgebraicDatatypeValues.Variants.funcons
    , Funcons.Core.Values.CompositeValues.AlgebraicDatatypeValues.Records.funcons
    , Funcons.Core.Values.CompositeValues.AlgebraicDatatypeValues.References.funcons
    , Funcons.Core.Values.PrimitiveValues.UnitType.funcons
    , Funcons.Core.Values.PrimitiveValues.UnicodeCharacters.funcons
    , Funcons.Core.Values.PrimitiveValues.Bits.funcons
    , Funcons.Core.Values.PrimitiveValues.Strings.funcons
    , Funcons.Core.Values.PrimitiveValues.Numbers.Integers.funcons
    , Funcons.Core.Values.PrimitiveValues.Numbers.Rationals.funcons
    , Funcons.Core.Values.PrimitiveValues.Numbers.IeeeFloats.funcons
    , Funcons.Core.Values.PrimitiveValues.Booleans.funcons
    , Funcons.Core.Abstractions.Closures.Close.funcons
    , Funcons.Core.Abstractions.Closures.Closure.funcons
    , Funcons.Core.Abstractions.Patterns.PatternPrefer.funcons
    , Funcons.Core.Abstractions.Patterns.Match.funcons
    , Funcons.Core.Abstractions.Patterns.Patterns.funcons
    , Funcons.Core.Abstractions.Patterns.PatternUnite.funcons
    , Funcons.Core.Abstractions.Patterns.PatternAny.funcons
    , Funcons.Core.Abstractions.Patterns.Case.funcons
    , Funcons.Core.Abstractions.Patterns.MatchLoosely.funcons
    , Funcons.Core.Abstractions.Patterns.PatternBind.funcons
    , Funcons.Core.Abstractions.IsGroundValue.funcons
    , Funcons.Core.Abstractions.Functions.Apply.funcons
    , Funcons.Core.Abstractions.Functions.Supply.funcons
    , Funcons.Core.Abstractions.Functions.BindingLambda.funcons
    , Funcons.Core.Abstractions.Functions.Curry.funcons
    , Funcons.Core.Abstractions.Functions.Lambda.funcons
    , Funcons.Core.Abstractions.Functions.Uncurry.funcons
    , Funcons.Core.Abstractions.Functions.PartialApply.funcons
    , Funcons.Core.Abstractions.Functions.Compose.funcons
    ]
entities = concat 
    [
     Funcons.Core.Computations.Sorts.entities
    , Funcons.Core.Computations.ControlFlow.Normal.Sequencing.LeftToRight.entities
    , Funcons.Core.Computations.ControlFlow.Normal.Sequencing.Atomic.entities
    , Funcons.Core.Computations.ControlFlow.Normal.Sequencing.Sequential.entities
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.VectorMap.entities
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.SetMap.entities
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.ListMap.entities
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.TupleMap.entities
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.MapMap.entities
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.ListsMap.entities
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.FilteringCollections.MultisetFilter.entities
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.FilteringCollections.SetFilter.entities
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.FilteringCollections.MapFilter.entities
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.FilteringCollections.ListFilter.entities
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.ReducingCollections.ListFoldl.entities
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.ReducingCollections.ListFoldr.entities
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Indefinite.While.entities
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Indefinite.DoWhile.entities
    , Funcons.Core.Computations.ControlFlow.Normal.Choosing.IfThenElse.entities
    , Funcons.Core.Computations.ControlFlow.Abnormal.Stuck.entities
    , Funcons.Core.Computations.ControlFlow.Abnormal.Throwing.Thrown.entities
    , Funcons.Core.Computations.ControlFlow.Abnormal.Throwing.HandleThrown.entities
    , Funcons.Core.Computations.ControlFlow.Abnormal.Throwing.Finally.entities
    , Funcons.Core.Computations.ControlFlow.Abnormal.Throwing.Throw.entities
    , Funcons.Core.Computations.ControlFlow.Abnormal.Throwing.HandleRecursively.entities
    , Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Plug.entities
    , Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.ResumeSignal.entities
    , Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Shift.entities
    , Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Prompt.entities
    , Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Control.entities
    , Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.CallCc.entities
    , Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Reset.entities
    , Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Hole.entities
    , Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Abort.entities
    , Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.ControlSignal.entities
    , Funcons.Core.Computations.ControlFlow.Abnormal.Failing.Else.entities
    , Funcons.Core.Computations.ControlFlow.Abnormal.Failing.CheckTrue.entities
    , Funcons.Core.Computations.ControlFlow.Abnormal.Failing.Fail.entities
    , Funcons.Core.Computations.ControlFlow.Abnormal.Failing.Signals.entities
    , Funcons.Core.Computations.ControlFlow.Abnormal.Failing.Dereference.entities
    , Funcons.Core.Computations.ControlFlow.Abnormal.Failing.Failed.entities
    , Funcons.Core.Computations.DataFlow.Interacting.PrintList.entities
    , Funcons.Core.Computations.DataFlow.Interacting.Print.entities
    , Funcons.Core.Computations.DataFlow.Interacting.StandardOut.entities
    , Funcons.Core.Computations.DataFlow.Interacting.Read.entities
    , Funcons.Core.Computations.DataFlow.Interacting.StandardIn.entities
    , Funcons.Core.Computations.DataFlow.Effect.entities
    , Funcons.Core.Computations.DataFlow.Storing.GeneralVariables.AllocateMap.entities
    , Funcons.Core.Computations.DataFlow.Storing.GeneralVariables.GeneralAssign.entities
    , Funcons.Core.Computations.DataFlow.Storing.GeneralVariables.GeneralAssigned.entities
    , Funcons.Core.Computations.DataFlow.Storing.GeneralVariables.AllocateVector.entities
    , Funcons.Core.Computations.DataFlow.Storing.Stores.entities
    , Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.CurrentValue.entities
    , Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.Assigned.entities
    , Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.AllocateInitialisedVariable.entities
    , Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.AllocateVariable.entities
    , Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.DeallocateVariable.entities
    , Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.Assign.entities
    , Funcons.Core.Computations.DataFlow.Storing.Store.entities
    , Funcons.Core.Computations.DataFlow.Storing.Variables.entities
    , Funcons.Core.Computations.DataFlow.Linking.AllocateInitialisedLink.entities
    , Funcons.Core.Computations.DataFlow.Linking.AllocateLink.entities
    , Funcons.Core.Computations.DataFlow.Linking.FollowIfLink.entities
    , Funcons.Core.Computations.DataFlow.Linking.LinkStore.entities
    , Funcons.Core.Computations.DataFlow.Linking.Links.entities
    , Funcons.Core.Computations.DataFlow.Linking.FollowLink.entities
    , Funcons.Core.Computations.DataFlow.Linking.LinkStores.entities
    , Funcons.Core.Computations.DataFlow.Linking.SetLink.entities
    , Funcons.Core.Computations.DataFlow.Giving.Given.entities
    , Funcons.Core.Computations.DataFlow.Giving.Give.entities
    , Funcons.Core.Computations.DataFlow.Giving.GivenValue.entities
    , Funcons.Core.Computations.DataFlow.Generating.AtomGenerator.entities
    , Funcons.Core.Computations.DataFlow.Generating.FreshAtom.entities
    , Funcons.Core.Computations.DataFlow.Generating.FreshBinder.entities
    , Funcons.Core.Computations.DataFlow.Binding.Recursion.Recursive.entities
    , Funcons.Core.Computations.DataFlow.Binding.Recursion.BindRecursively.entities
    , Funcons.Core.Computations.DataFlow.Binding.Recursion.BoundRecursively.entities
    , Funcons.Core.Computations.DataFlow.Binding.Bound.entities
    , Funcons.Core.Computations.DataFlow.Binding.Environments.entities
    , Funcons.Core.Computations.DataFlow.Binding.Scope.entities
    , Funcons.Core.Computations.DataFlow.Binding.Accumulate.entities
    , Funcons.Core.Computations.DataFlow.Binding.Bind.entities
    , Funcons.Core.Computations.DataFlow.Binding.Environment.entities
    , Funcons.Core.Values.Types.entities
    , Funcons.Core.Values.CompositeValues.Collections.DirectedGraphs.entities
    , Funcons.Core.Values.CompositeValues.Collections.Tuples.entities
    , Funcons.Core.Values.CompositeValues.AlgebraicDatatypeValues.Variants.entities
    , Funcons.Core.Values.CompositeValues.AlgebraicDatatypeValues.Records.entities
    , Funcons.Core.Values.CompositeValues.AlgebraicDatatypeValues.References.entities
    , Funcons.Core.Values.PrimitiveValues.UnitType.entities
    , Funcons.Core.Values.PrimitiveValues.UnicodeCharacters.entities
    , Funcons.Core.Values.PrimitiveValues.Bits.entities
    , Funcons.Core.Values.PrimitiveValues.Strings.entities
    , Funcons.Core.Values.PrimitiveValues.Numbers.Integers.entities
    , Funcons.Core.Values.PrimitiveValues.Numbers.Rationals.entities
    , Funcons.Core.Values.PrimitiveValues.Numbers.IeeeFloats.entities
    , Funcons.Core.Values.PrimitiveValues.Booleans.entities
    , Funcons.Core.Abstractions.Closures.Close.entities
    , Funcons.Core.Abstractions.Closures.Closure.entities
    , Funcons.Core.Abstractions.Patterns.PatternPrefer.entities
    , Funcons.Core.Abstractions.Patterns.Match.entities
    , Funcons.Core.Abstractions.Patterns.Patterns.entities
    , Funcons.Core.Abstractions.Patterns.PatternUnite.entities
    , Funcons.Core.Abstractions.Patterns.PatternAny.entities
    , Funcons.Core.Abstractions.Patterns.Case.entities
    , Funcons.Core.Abstractions.Patterns.MatchLoosely.entities
    , Funcons.Core.Abstractions.Patterns.PatternBind.entities
    , Funcons.Core.Abstractions.IsGroundValue.entities
    , Funcons.Core.Abstractions.Functions.Apply.entities
    , Funcons.Core.Abstractions.Functions.Supply.entities
    , Funcons.Core.Abstractions.Functions.BindingLambda.entities
    , Funcons.Core.Abstractions.Functions.Curry.entities
    , Funcons.Core.Abstractions.Functions.Lambda.entities
    , Funcons.Core.Abstractions.Functions.Uncurry.entities
    , Funcons.Core.Abstractions.Functions.PartialApply.entities
    , Funcons.Core.Abstractions.Functions.Compose.entities
    ]
types = typeEnvUnions 
    [
     Funcons.Core.Computations.Sorts.types
    , Funcons.Core.Computations.ControlFlow.Normal.Sequencing.LeftToRight.types
    , Funcons.Core.Computations.ControlFlow.Normal.Sequencing.Atomic.types
    , Funcons.Core.Computations.ControlFlow.Normal.Sequencing.Sequential.types
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.VectorMap.types
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.SetMap.types
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.ListMap.types
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.TupleMap.types
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.MapMap.types
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.MappingCollections.ListsMap.types
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.FilteringCollections.MultisetFilter.types
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.FilteringCollections.SetFilter.types
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.FilteringCollections.MapFilter.types
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.FilteringCollections.ListFilter.types
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.ReducingCollections.ListFoldl.types
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Definite.ReducingCollections.ListFoldr.types
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Indefinite.While.types
    , Funcons.Core.Computations.ControlFlow.Normal.Iterating.Indefinite.DoWhile.types
    , Funcons.Core.Computations.ControlFlow.Normal.Choosing.IfThenElse.types
    , Funcons.Core.Computations.ControlFlow.Abnormal.Stuck.types
    , Funcons.Core.Computations.ControlFlow.Abnormal.Throwing.Thrown.types
    , Funcons.Core.Computations.ControlFlow.Abnormal.Throwing.HandleThrown.types
    , Funcons.Core.Computations.ControlFlow.Abnormal.Throwing.Finally.types
    , Funcons.Core.Computations.ControlFlow.Abnormal.Throwing.Throw.types
    , Funcons.Core.Computations.ControlFlow.Abnormal.Throwing.HandleRecursively.types
    , Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Plug.types
    , Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.ResumeSignal.types
    , Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Shift.types
    , Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Prompt.types
    , Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Control.types
    , Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.CallCc.types
    , Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Reset.types
    , Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Hole.types
    , Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.Abort.types
    , Funcons.Core.Computations.ControlFlow.Abnormal.Continuations.ControlSignal.types
    , Funcons.Core.Computations.ControlFlow.Abnormal.Failing.Else.types
    , Funcons.Core.Computations.ControlFlow.Abnormal.Failing.CheckTrue.types
    , Funcons.Core.Computations.ControlFlow.Abnormal.Failing.Fail.types
    , Funcons.Core.Computations.ControlFlow.Abnormal.Failing.Signals.types
    , Funcons.Core.Computations.ControlFlow.Abnormal.Failing.Dereference.types
    , Funcons.Core.Computations.ControlFlow.Abnormal.Failing.Failed.types
    , Funcons.Core.Computations.DataFlow.Interacting.PrintList.types
    , Funcons.Core.Computations.DataFlow.Interacting.Print.types
    , Funcons.Core.Computations.DataFlow.Interacting.StandardOut.types
    , Funcons.Core.Computations.DataFlow.Interacting.Read.types
    , Funcons.Core.Computations.DataFlow.Interacting.StandardIn.types
    , Funcons.Core.Computations.DataFlow.Effect.types
    , Funcons.Core.Computations.DataFlow.Storing.GeneralVariables.AllocateMap.types
    , Funcons.Core.Computations.DataFlow.Storing.GeneralVariables.GeneralAssign.types
    , Funcons.Core.Computations.DataFlow.Storing.GeneralVariables.GeneralAssigned.types
    , Funcons.Core.Computations.DataFlow.Storing.GeneralVariables.AllocateVector.types
    , Funcons.Core.Computations.DataFlow.Storing.Stores.types
    , Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.CurrentValue.types
    , Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.Assigned.types
    , Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.AllocateInitialisedVariable.types
    , Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.AllocateVariable.types
    , Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.DeallocateVariable.types
    , Funcons.Core.Computations.DataFlow.Storing.SimpleVariables.Assign.types
    , Funcons.Core.Computations.DataFlow.Storing.Store.types
    , Funcons.Core.Computations.DataFlow.Storing.Variables.types
    , Funcons.Core.Computations.DataFlow.Linking.AllocateInitialisedLink.types
    , Funcons.Core.Computations.DataFlow.Linking.AllocateLink.types
    , Funcons.Core.Computations.DataFlow.Linking.FollowIfLink.types
    , Funcons.Core.Computations.DataFlow.Linking.LinkStore.types
    , Funcons.Core.Computations.DataFlow.Linking.Links.types
    , Funcons.Core.Computations.DataFlow.Linking.FollowLink.types
    , Funcons.Core.Computations.DataFlow.Linking.LinkStores.types
    , Funcons.Core.Computations.DataFlow.Linking.SetLink.types
    , Funcons.Core.Computations.DataFlow.Giving.Given.types
    , Funcons.Core.Computations.DataFlow.Giving.Give.types
    , Funcons.Core.Computations.DataFlow.Giving.GivenValue.types
    , Funcons.Core.Computations.DataFlow.Generating.AtomGenerator.types
    , Funcons.Core.Computations.DataFlow.Generating.FreshAtom.types
    , Funcons.Core.Computations.DataFlow.Generating.FreshBinder.types
    , Funcons.Core.Computations.DataFlow.Binding.Recursion.Recursive.types
    , Funcons.Core.Computations.DataFlow.Binding.Recursion.BindRecursively.types
    , Funcons.Core.Computations.DataFlow.Binding.Recursion.BoundRecursively.types
    , Funcons.Core.Computations.DataFlow.Binding.Bound.types
    , Funcons.Core.Computations.DataFlow.Binding.Environments.types
    , Funcons.Core.Computations.DataFlow.Binding.Scope.types
    , Funcons.Core.Computations.DataFlow.Binding.Accumulate.types
    , Funcons.Core.Computations.DataFlow.Binding.Bind.types
    , Funcons.Core.Computations.DataFlow.Binding.Environment.types
    , Funcons.Core.Values.Types.types
    , Funcons.Core.Values.CompositeValues.Collections.DirectedGraphs.types
    , Funcons.Core.Values.CompositeValues.Collections.Tuples.types
    , Funcons.Core.Values.CompositeValues.AlgebraicDatatypeValues.Variants.types
    , Funcons.Core.Values.CompositeValues.AlgebraicDatatypeValues.Records.types
    , Funcons.Core.Values.CompositeValues.AlgebraicDatatypeValues.References.types
    , Funcons.Core.Values.PrimitiveValues.UnitType.types
    , Funcons.Core.Values.PrimitiveValues.UnicodeCharacters.types
    , Funcons.Core.Values.PrimitiveValues.Bits.types
    , Funcons.Core.Values.PrimitiveValues.Strings.types
    , Funcons.Core.Values.PrimitiveValues.Numbers.Integers.types
    , Funcons.Core.Values.PrimitiveValues.Numbers.Rationals.types
    , Funcons.Core.Values.PrimitiveValues.Numbers.IeeeFloats.types
    , Funcons.Core.Values.PrimitiveValues.Booleans.types
    , Funcons.Core.Abstractions.Closures.Close.types
    , Funcons.Core.Abstractions.Closures.Closure.types
    , Funcons.Core.Abstractions.Patterns.PatternPrefer.types
    , Funcons.Core.Abstractions.Patterns.Match.types
    , Funcons.Core.Abstractions.Patterns.Patterns.types
    , Funcons.Core.Abstractions.Patterns.PatternUnite.types
    , Funcons.Core.Abstractions.Patterns.PatternAny.types
    , Funcons.Core.Abstractions.Patterns.Case.types
    , Funcons.Core.Abstractions.Patterns.MatchLoosely.types
    , Funcons.Core.Abstractions.Patterns.PatternBind.types
    , Funcons.Core.Abstractions.IsGroundValue.types
    , Funcons.Core.Abstractions.Functions.Apply.types
    , Funcons.Core.Abstractions.Functions.Supply.types
    , Funcons.Core.Abstractions.Functions.BindingLambda.types
    , Funcons.Core.Abstractions.Functions.Curry.types
    , Funcons.Core.Abstractions.Functions.Lambda.types
    , Funcons.Core.Abstractions.Functions.Uncurry.types
    , Funcons.Core.Abstractions.Functions.PartialApply.types
    , Funcons.Core.Abstractions.Functions.Compose.types
    ]
